function [Mat] = getSysMatpolefem2(p,e,bd,a,b,ML,MR,s0)
% echo : flag turning output in shell on or off
% print : flag turning several plots on or off

Vl=potential_func(p(bd(1)));   % Potential value on xl
Vr=potential_func(p(bd(2))); % Potential value on xr  

f  = @(x) potential_func(x);
%g1 = @(x,xl,xu) (xu-x)./(xu-xl);
%g2 = @(x,xl,xu) (x-xl)./(xu-xl);

g1 = @(x,xl,xu) 2*(x-(xl+xu)/2).*(x-xu)./(xu-xl).^2;
g2 = @(x,xl,xu) -4*(x-xl).*(x-xu)./(xu-xl).^2;
g3 = @(x,xl,xu) 2*(x-xl).*(x-(xl+xu)/2)./(xu-xl).^2;



Mloc = a/30 *[ 4 , 2, -1; ...
               2, 16,  2; ...
	      -1,  2,  4]; 

Aloc =  b/3*[ 7 , -8,  1; ...
             -8 , 16, -8; ... 
	      1 , -8,  7]; 

ne = size(e,2);
np = size(p,2);
ndof = np;

%ne=(np+1)/2-1;

%fprintf('ne = %d ; np = %d\n',ne,np);
% Equations Physical domain
MMPD = sparse(ndof,ndof); % Massmatrix
KKPD = sparse(ndof,ndof); 

for kk = 1:2:ne
  MMPD(e(:,kk),e(:,kk)) = MMPD(e(:,kk),e(:,kk)) + (p(e(3,kk))-p(e(1,kk)))*Mloc; 
  KKPD(e(:,kk),e(:,kk)) = KKPD(e(:,kk),e(:,kk)) - (1/(p(e(3,kk))-p(e(1,kk))))*Aloc; 
  xl = p(e(1,kk));
  xu = p(e(3,kk));

  f11 = @(x) f(x).*g1(x,xl,xu).*g1(x,xl,xu);
  f12 = @(x) f(x).*g1(x,xl,xu).*g2(x,xl,xu);
  f13 = @(x) f(x).*g1(x,xl,xu).*g3(x,xl,xu);
  f22 = @(x) f(x).*g2(x,xl,xu).*g2(x,xl,xu);
  f23 = @(x) f(x).*g2(x,xl,xu).*g3(x,xl,xu);
  f33 = @(x) f(x).*g3(x,xl,xu).*g3(x,xl,xu);
  El11=quad(f11,xl,xu);
  El12=quad(f12,xl,xu);
  El13=quad(f13,xl,xu);
  El22=quad(f22,xl,xu);
  El23=quad(f23,xl,xu);
  El33=quad(f33,xl,xu);
  El1=[ El11 , El12, El13; ...,
        El12 , El22, El23; ...,
        El13 , El23, El33];    
  KKPD(e(:,kk),e(:,kk)) = KKPD(e(:,kk),e(:,kk)) - El1; 
end
Mat.MMPD = MMPD;
%spy(MMPD);fprintf('Type a character\n');pause;

MMPD = MMPD(2:end-1,:);
KKPD = KKPD(2:end-1,:);

P_PD   = sparse(ML+[1:ndof],[1:ndof],ones(1,ndof),ndof+ML+MR,ndof);
P_PDI  = sparse(ML+[2:ndof-1],[1:ndof-2],ones(1,ndof-2),ndof+ML+MR,ndof-2);
MMPDT = P_PDI*MMPD*P_PD'; 
KKPDT = P_PDI*KKPD*P_PD';

%fprintf('ndof = %d ; ML = %d\n ; MR = %d ; ndof+ML+MR = %d\n',ndof,ML,MR,ndof+ML+MR);

%spy(MMPDT);fprintf('Type a character\n');pause;

h = p(3)-p(1);
% Coupling equation s^0
MMC = sparse([ a, 4*a*h/30, 2*a*h/30 , -a*h/30, 0, 0, 0, 0;
	       0, 0 ,0, 0,-a*h/30, 2*a*h/30, 4*a*h/30, a]);

KKC = sparse([ -Vl, -Vl*h/3-b*7/h/3, -Vl*h/6+8*b/h/3, -b/h/3,0, 0, 0, 0; ...
	       0, 0, 0, 0, -b/h/3, -Vr*h/6+8*b/h/3 , -Vr*h/3-b*7/h/3, -Vr]);
N1C =  sparse([0, b, 0, 0, 0, 0, 0, 0; ...
	       0, 0, 0, 0, 0, 0, b, 0]);
N2C =  sparse([b, 0, 0, 0, 0, 0, 0, 0; ...
	       0, 0, 0, 0, 0, 0, 0, b]);

KSC =  KKC  + s0*N1C + s0^2*N2C;

P_C =  sparse([ML ML+1 ML+2 ML+3 ML+ndof-2 ML+ndof-1 ML+ndof ML+ndof+1],...
		      [1 : 8],ones(1,8),ndof+ML+MR,8);
P_CI = sparse([ML+1,ML+ndof],[1 2],ones(1,2),ndof+ML+MR,2);

MMCT = P_CI*MMC*P_C';
KKCT = P_CI*KKC*P_C';
KSCT = P_CI*KSC*P_C';
N1CT = P_CI*N1C*P_C';
N2CT = P_CI*N2C*P_C';

% a0 Equation s^1
% 
MMA0 = sparse([a, 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, a]);
KKA0 = sparse([-Vl, 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, -Vr]);
N1A0 = sparse([ 0, 0, 2*b, 0, 0, 0;
		0, 0, 0, 2*b, 0,  0]);
N2A0 = sparse([b , 4*b, 0, 0, 0, 0;
	       0, 0, 0, 0, 4*b, b]);

KSA0 =  KKA0 + s0^2*N2A0 + s0*N1A0;

P_A0 =  sparse([ML-1 ML ML+1 ML+ndof ML+ndof+1 ML+ndof+2],...
		      [1 : 6],ones(1,6),ndof+ML+MR,6);
P_A0I = sparse([ML,ML+ndof+1],[1 2],ones(1,2),ndof+ML+MR,2);

MMA0T = P_A0I*MMA0*P_A0';
KKA0T = P_A0I*KKA0*P_A0';
KSA0T = P_A0I*KSA0*P_A0';
N1A0T = P_A0I*N1A0*P_A0';
N2A0T = P_A0I*N2A0*P_A0';

% a1 Equation s^2
% 
MMA1 = sparse([a, -a, 0, 0, 0, 0;
	       0, 0, 0, 0, -a, a]);
KKA1 = sparse([-Vl, Vl, 0, 0, 0,   0;
	         0,  0, 0, 0, +Vr, -Vr]);
N1A1 = sparse([0, 0, 0, 0, 0, 0;
	       0, 0, 0, 0, 0, 0]);
N2A1 = sparse([1*b, 3*b, 4*b, 0, 0, 0;
	       0, 0, 0, 4*b, 3*b, 1*b]);
KSA1 =  KKA1 + s0^2*N2A1 + s0*N1A1;

P_A1 =  sparse([ML-2 ML-1 ML ML+ndof+1 ML+ndof+2 ML+ndof+3],...
		      [1 : 6],ones(1,6),ndof+ML+MR,6);
P_A1I = sparse([ML-1,ML+ndof+2],[1 2],ones(1,2),ndof+ML+MR,2);

MMA1T = P_A1I*MMA1*P_A1';
KSA1T = P_A1I*KSA1*P_A1';
KKA1T = P_A1I*KKA1*P_A1';
N1A1T = P_A1I*N1A1*P_A1';
N2A1T = P_A1I*N2A1*P_A1';

% aj Equations
% p*ajm1 -2*p*aj + p*ajp1 =  (s0^2-k^2-2*d*s0)*ajp1 +2*(s0^2+k^2)*aj +  (s0^2-k^2+2*d*s0)*ajm1
eL = ones(ML-1,1);
xAJL = spdiags([eL -2*eL eL],-1:1,ML-1,ML-1);
yAJL = spdiags([eL  2*eL eL],-1:1,ML-1,ML-1);
zAJL = spdiags([-eL 0*eL eL],-1:1,ML-1,ML-1);

MMAJL = a*xAJL;
KKAJL = -Vl*xAJL;
N1AJL = 0*zAJL;
N2AJL = yAJL;
KSAJL = KKAJL + b*s0^2*N2AJL;

MMAJL = MMAJL(1:end-1,:);
KSAJL = KSAJL(1:end-1,:);
KKAJL = KKAJL(1:end-1,:);
N1AJL = N1AJL(1:end-1,:);
N2AJL = N2AJL(1:end-1,:);

P_AJL = sparse([1:ML-1],[1:ML-1],ones(1,ML-1),ndof+ML+MR,ML-1);
P_AJLI = sparse([1:ML-2],[1:ML-2],ones(1,ML-2),ndof+ML+MR,ML-2);
MMAJLT = P_AJLI*MMAJL*P_AJL';
KSAJLT = P_AJLI*KSAJL*P_AJL';
KKAJLT = P_AJLI*KKAJL*P_AJL';
N1AJLT = P_AJLI*N1AJL*P_AJL';
N2AJLT = P_AJLI*N2AJL*P_AJL';

eR = ones(MR-1,1);
xAJR = spdiags([eR -2*eR eR],-1:1,MR-1,MR-1);
yAJR = spdiags([eR  2*eR eR],-1:1,MR-1,MR-1);
zAJR = spdiags([eR  0*eR -eR],-1:1,MR-1,MR-1);
MMAJR = a*xAJR;
KKAJR = -Vr*xAJR;
N1AJR = 0*zAJR;
N2AJR = yAJR;
KSAJR = KKAJR + b*s0^2*N2AJR;

MMAJR = MMAJR(2:end,:);
KSAJR = KSAJR(2:end,:);
KKAJR = KKAJR(2:end,:);
N1AJR = N1AJR(2:end,:);
N2AJR = N2AJR(2:end,:);

P_AJR =  sparse([ndof+ML+2:ndof+ML+MR],[1:MR-1],ones(1,MR-1),ndof+ML+MR,MR-1);
P_AJRI = sparse([ndof+ML+3:ndof+ML+MR],[1:MR-2],ones(1,MR-2),ndof+ML+MR,MR-2);
MMAJRT = P_AJRI*MMAJR*P_AJR';
KSAJRT = P_AJRI*KSAJR*P_AJR';
KKAJRT = P_AJRI*KKAJR*P_AJR';
N1AJRT = P_AJRI*N1AJR*P_AJR';
N2AJRT = P_AJRI*N2AJR*P_AJR';

Mat.M = MMPDT+MMCT+MMA0T+MMA1T+MMAJLT+MMAJRT;
Mat.A = KKPDT+KSCT+KSA0T+KSA1T+KSAJLT+KSAJRT;
Mat.KK = KKPDT+KKCT+KKA0T+KKA1T+KKAJLT+KKAJRT;
Mat.N1 = N1CT+N1A0T+N1A1T+N1AJLT+N1AJRT;
Mat.N2 = N2CT+N2A0T+N2A1T+N2AJLT+N2AJRT;
Mat.P_PD = P_PD;
%spy(Mat.M);