clear all
fontsize = 24;
fontsizel = 26;

a = 1;
b = 1;

methods{1}.name = 'arnold';
methods{1}.leg_line = '-';
methods{1}.leg_symbol = 'o';
methods{1}.leg_col = [0 1 0];

methods{2}.name = 'fd';
methods{2}.leg_line = '-';
methods{2}.leg_symbol = 's';
methods{2}.leg_col = [174/256 0 1];

methods{3}.name = 'baskpopMod';
methods{3}.leg_line = ':';
methods{3}.leg_symbol = '*';
methods{3}.leg_col = [0 0 1];

methods{4}.name = 'polefd';
methods{4}.leg_line = '-.';
methods{4}.leg_symbol = 'd';
methods{4}.leg_col = [0 0.5 1];

methods{5}.name = 'pmlfd';
methods{5}.leg_line = '--';
methods{5}.leg_symbol = 'p';
methods{5}.leg_col = [0 1 1];

methods{6}.name = 'dimenza2';
methods{6}.leg_line = '-';
methods{6}.leg_symbol = '^';
methods{6}.leg_col = [1 0 0];

methods{7}.name = 'pade2';
methods{7}.leg_line = ':';
methods{7}.leg_symbol = 'd';
methods{7}.leg_col = [1 0.5 0];

methods{8}.name = 'szeftel2';
methods{8}.leg_line = '-.';
methods{8}.leg_symbol = 'p';
methods{8}.leg_col = [1 100/256 177/256];

methods{9}.name = 'fem';
methods{9}.leg_line = '-';
methods{9}.leg_symbol = 's';
methods{9}.leg_col = [1 0 1];

methods{10}.name = 'fem2';
methods{10}.leg_line = '-';
methods{10}.leg_symbol = '*';
methods{10}.leg_col = [139/256,97/256,42/256];

methods{11}.name = 'pmlfemO1';
methods{11}.leg_line = ':';
methods{11}.leg_symbol = 'd';
methods{11}.leg_col = [163/256 75/256 96/256];

methods{12}.name = 'pmlfemO2';
methods{12}.leg_line = ':';
methods{12}.leg_symbol = 'p';
methods{12}.leg_col = [163/256,75/256,0/256];

methods{13}.name = 'polefem';
methods{13}.leg_line = '-.';
methods{13}.leg_symbol = '<';
methods{13}.leg_col = [159/256 136/256 147/256];

methods{14}.name = 'polefem2';
methods{14}.leg_line = '-.';
methods{14}.leg_symbol = 's';
methods{14}.leg_col = [0 0 0];

methods{15}.name = 'fevens';
methods{15}.leg_line = '-';
methods{15}.leg_symbol = '*';
methods{15}.leg_col = [100/256 1 56/256];

methods{16}.name = 'kuska';
methods{16}.leg_line = ':';
methods{16}.leg_symbol = '<';
methods{16}.leg_col = [100/256 1 183/256];

methods{17}.name = 'shibata';
methods{17}.leg_line = '-.';
methods{17}.leg_symbol = 's';
methods{17}.leg_col = [61/256 137/256 36/256];

figure(100);clf
for mgi = 1:4  
  phx = plot([0.3 0.7],[5-mgi 5-mgi]); hold on
  set(phx,'LineWidth',2)
  set(phx,'LineStyle',methods{mgi}.leg_line)
  set(phx,'Color',methods{mgi}.leg_col)  
  phx = plot([0.5],[5-mgi]); hold on
  set(phx,'Marker',methods{mgi}.leg_symbol)
  set(phx,'LineWidth',2)
  set(phx,'MarkerSize',16)
  set(phx,'Color',methods{mgi}.leg_col) 
  name = regexprep(methods{mgi}.name,'_',' ')
  text(0.72,5-mgi,name,'FontSize',16)
  xlim([0.3 1.3])
  ylim([0 22])
end
axis off
set(gca,'Position',[0.2 0.2 0.7 0.7]);
set(gcf,'PaperUnits','inch')
set(gcf,'PaperPositionMode','manual')
set(gcf,'PaperPosition',[1 1 3.5 9])
print -depsc method_legend

for gk = 1:1
  mindx = inf;
  maxdx = 0;
  mincpu = inf;
  maxcpu = 0;

  for kk = 1:8
    figure(kk); clf
  end

  if gk == 1
    methodgroup = 'FeJi_';
    mgiv = [ 15 16 17]
    yliml2 = [1e-6 1]
    ylimtf = [1e-11 1e-1]
  elseif gk == 2
    methodgroup = 'FD_';
    mgiv = [1 2 3 4 5 18]
    yliml2 = [1e-6 1]
    ylimtf = [1e-12 1e-4]
  elseif gk == 3
    methodgroup = 'ROOT_';
    mgiv = [1 6 7 8 19]
    yliml2 = [1e-6 1]
    ylimtf = [1e-12 1e-1]
  elseif gk == 4
    methodgroup = 'FEM_';
    mgiv = [1 9 10 11 12 13 14 20 21]
    mgiv = [1 2 3 4 5 6 7]
    yliml2 = [1e-6 1]
    ylimtf = [1e-12 1e-0]
  end  
  
  legendstring = [];
  
  for mgi = mgiv
    
    eval(sprintf('load erg2_a%gb%g%s',10*a,10*b,methods{mgi}.name))
    
    [nx,nt] = size(Error);
    
    clear errtf_t errtm_t errl2_t cpu_tN cpu_t1
    for nnt = 1:nt
      errtf_t(nnt)  = Error{end,nnt}.etf;
      errtm_t(nnt)  = Error{end,nnt}.etm;
      errl2_tN(nnt) = Error{end,nnt}.el2;
      cpu_tN(nnt)   = Error{end,nnt}.cput;
      cpu_t1(nnt)   = Error{1,nnt}.cput;
    end

    clear errtf_x errtm_x errl2_x cpu_x
    for nnx = 1:nx
      errtf_x(nnx) = Error{nnx,end}.etf;
      errtm_x(nnx) = Error{nnx,end}.etm;
      errl2_x(nnx) = Error{nnx,end}.el2;
      cpu_x(nnx)   = Error{nnx,end}.cput;
    end
    
    figure(1)
    phx=loglog(dtVec,errtf_t); hold on
    setMarkS
    
    figure(2)
    phx=loglog(dtVec,errl2_tN); hold on
    setMarkS
    
    figure(3)
    phx=loglog(cpu_tN,errl2_tN); hold on
    setMarkS
    
    mincpu = min(mincpu,min(cpu_tN));
    maxcpu = max(maxcpu,max(cpu_tN));
    mindx = min(mindx,min((data.x1-data.x0)./NVec));
    maxdx = max(maxdx,max((data.x1-data.x0)./NVec));
    
    figure(4)
    phx=loglog((data.x1-data.x0)./NVec,errtf_x); hold on
    setMarkS
    
    figure(5)
    phx=loglog((data.x1-data.x0)./NVec,errl2_x); hold on
    setMarkS
    
    figure(6)
    phx = semilogy(Error{end,end}.tev(1:8:end),Error{end,end}.errorev(1:8:end)); hold on
    setMarkS
    
    figure(7)
    phx=loglog(4./dtVec(1:end),cpu_tN(1:end)); hold on
    setMarkS
    
    figure(8)
    phx=loglog(4./dtVec(1:end),cpu_t1(1:end)); hold on
    setMarkS
    
    
    legendstring = [legendstring {methods{mgi}.name}];
    
  end
  legendstring = regexprep(legendstring,'arnold','ArnEhr');
  legendstring = regexprep(legendstring,'baskpopMod','BaskPo');
  legendstring = regexprep(legendstring,'baskpopCor','BaskPo');
  legendstring = regexprep(legendstring,'dimenza2','Di Menza');
  legendstring = regexprep(legendstring,'pmlfd','pml FD');
  legendstring = regexprep(legendstring,'pmlfem1adaptive','pml FEM 1');
  legendstring = regexprep(legendstring,'pmlfem2adaptive','pml FEM 2');
  legendstring = regexprep(legendstring,'polefem1','pole FEM 1');
  legendstring = regexprep(legendstring,'polefem2','pole FEM 2');
  legendstring = regexprep(legendstring,'polefd','pole FD');
  legendstring = regexprep(legendstring,'fd','FD');
  legendstring = regexprep(legendstring,'fem2','FEM 2');
  legendstring = regexprep(legendstring,'fem3','FEM 3');
  legendstring = regexprep(legendstring,'fem', 'FEM 1');
  legendstring = regexprep(legendstring,'fevens','Fevens');
  legendstring = regexprep(legendstring,'kuska','Kuska');
  legendstring = regexprep(legendstring,'pade2','Pade');
  legendstring = regexprep(legendstring,'shibata','Shibata');
  legendstring = regexprep(legendstring,'szeftel2','Szeftel');
  
  ytickv = [1e-12 1e-10 1e-8 1e-6 1e-4 1e-2 1];
  xtickv = [1e-4 1e-3 1e-2 1e-1 1 1e1 1e2 1e3 1e4];
  figure(1)
  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  xlabel('dt');
  ylabel('errorT')
  ylim(ylimtf)
  xlim([0.8*min(dtVec),1.2*max(dtVec)])
  set(gca,'YTick',ytickv)
  set(gca,'XTick',xtickv)
  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc errort_tf_%snlFS',methodgroup))
  lh = legend(legendstring,'Location','SouthEast','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc errort_tf_%sFS',methodgroup))
  
  figure(2)
  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  xlabel('dt');
  ylabel('errorl2')
  ylim(yliml2)
  xlim([0.8*min(dtVec),1.2*max(dtVec)])
  set(gca,'YTick',ytickv)
  set(gca,'XTick',xtickv)

  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc errort_l2_%snlFS',methodgroup))
  legend(legendstring,'Location','SouthEast','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc errort_l2_%sFS',methodgroup))
  
  figure(3)
  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  xlabel('cput');
  ylabel('errorl2')
  ylim(yliml2)
  xlim([0.8*mincpu 1.2*maxcpu])
  set(gca,'YTick',ytickv)
  set(gca,'XTick',xtickv)
  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc errorcput_l2_%snlFS',methodgroup))
  legend(legendstring,'Location','SouthWest','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc errorcput_l2_%sFS',methodgroup))
  
  figure(4)

  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  xlabel('dx');
  ylabel('errorT')
  ylim(ylimtf)
  xlim([0.8*mindx 1.2*maxdx])
  set(gca,'YTick',ytickv)
  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc errorx_tf_%snlFS',methodgroup))
  legend(legendstring,'Location','SouthEast','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc errorx_tf_%sFS',methodgroup))
  
  figure(5)
  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  xlabel('dx');
  ylabel('errorl2')
  ylim(yliml2)
  xlim([0.8*mindx 1.2*maxdx])
  set(gca,'YTick',ytickv)
  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc errorx_l2_%snlFS',methodgroup))
  legend(legendstring,'Location','SouthEast','FontSize',fontsizel)  
  legend('boxoff')
  eval(sprintf('print -depsc errorx_l2_%sFS',methodgroup))
  
  figure(6)
  ylim([1e-11 3e-1])
  xlim([-0.1 4.1])
  set(gca,'LineWidth',2)
  set(gca,'FontSize',fontsize)
  set(gca,'YTick',ytickv)
  xlabel('time')
  ylabel('errorl2')
  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc evol_error_%snlFS',methodgroup))
  legend(legendstring,'Location','NorthEastOutside','FontSize',fontsizel+2)
  legend('boxoff')
  eval(sprintf('print -depsc evol_error_%sFS',methodgroup))
  
  figure(7)
  set(gca,'FontSize',fontsize)
  set(gca,'LineWidth',2)
  xlabel('steps');
  ylabel('cput')
  xlim([0.8*min(4./dtVec(1:end)),1.2*max(4./dtVec(1:end))])  
%  xlim([0 1.2*max(4./dtVec)])  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc stepscput_N_%snlFS',methodgroup))
  legend(legendstring,'Location','NorthWest','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc stepscput_N_%sFS',methodgroup))
  
  figure(8)
  set(gca,'FontSize',fontsize)
  set(gca,'LineWidth',2)
  xlabel('steps');
  ylabel('cput')
  xlim([0.8*min(4./dtVec(1:end)),1.2*max(4./dtVec(1:end))])  
%  xlim([0 1.2*max(4./dtVec)])  
  set(gca,'Position',[0.2 0.2 0.7 0.7]);
  set(gcf,'PaperUnits','inch')
  set(gcf,'PaperPositionMode','manual')
  set(gcf,'PaperPosition',[1 1 9 7])
  eval(sprintf('print -depsc stepscput_1_%snlFS',methodgroup))
  legend(legendstring,'Location','NorthWest','FontSize',fontsizel)
  legend('boxoff')
  eval(sprintf('print -depsc stepscput_1_%sFS',methodgroup))
  pause
end