function [A]=massMatrix2(N,dx)
% Antoine-Besse April 2004
% Assembling of the finite element mass matrix.
% Quadratic Finite Elements
% N : size
% dx : mesh size

% Elementary matrix
El1=(dx/30)*[4 , 2, -1; ...,
             2 ,16, 2 ; ...,
            -1 , 2 , 4]; 
e=zeros(N+2,1);

A=spdiags([e,e,e,e,e],[-2:2],N+2,N+2);
for j=1:2:N,
    A(j:j+2,j:j+2)=A(j:j+2,j:j+2)+El1;
end
